/********************
 **
 **  Z-matrix Editor ``KUMI''
 **
 **  copyright by Ryo MIYAMOTO, 1997-2001
 **
 ** $Id: initatom.c,v 1.1.1.1 2001/01/15 07:43:48 rmiya Exp $ 
 **
 ********************/

#include "kumi02.h"

void initElementData(void)
{
  /* KagakuBinran II-725 , vdW radii(v) or metal-radii*1.4(m) in \AAngstrom */
  /* See color name as /usr/X11R6/lib/X11/rgb.txt  */
  element[0].Name="XX"; element[0].VdwRadii=0.2 /**/; element[0].ColorName="Black";

  element[1].Name="H "; element[1].VdwRadii=1.20/*v*/; element[1].ColorName="WhiteSmoke";
  element[2].Name="HE"; element[2].VdwRadii=1.40/*v*/; element[2].ColorName="LightSlateGrey";

  element[3].Name="LI"; element[3].VdwRadii=1.82/*v*/; element[3].ColorName="LightSlateGrey";
  element[4].Name="BE"; element[4].VdwRadii=1.554/*m1.11*/; element[4].ColorName="LightSlateGrey";
  element[5].Name="B "; element[5].VdwRadii=1.7/***/; element[5].ColorName="LightYellow";
  element[6].Name="C "; element[6].VdwRadii=1.70/*v*/; element[6].ColorName="IndianRed";
  element[7].Name="N "; element[7].VdwRadii=1.55/*v*/; element[7].ColorName="RoyalBlue";
  element[8].Name="O "; element[8].VdwRadii=1.52/*v*/; element[8].ColorName="tomato";
  element[9].Name="F "; element[9].VdwRadii=1.47/*v*/; element[9].ColorName="YellowGreen";
  element[10].Name="NE"; element[10].VdwRadii=1.54/*v*/; element[10].ColorName="LightGrey";

  element[11].Name="NA"; element[11].VdwRadii=2.27/*v*/; element[11].ColorName="GhostWhite";
  element[12].Name="MG"; element[12].VdwRadii=1.73/*v*/; element[12].ColorName="LightGrey";
  element[13].Name="AL"; element[13].VdwRadii=2.002/*m1.43*/; element[13].ColorName="FloralWhite";
  element[14].Name="SI"; element[14].VdwRadii=2.10/*v*/; element[14].ColorName="DimGrey";
  element[15].Name="P "; element[15].VdwRadii=1.80/*v*/; element[15].ColorName="khaki";
  element[16].Name="S "; element[16].VdwRadii=1.80/*v*/; element[16].ColorName="DarkOrange";
  element[17].Name="CL"; element[17].VdwRadii=1.75/*v*/; element[17].ColorName="PaleGreen";
  element[18].Name="AR"; element[18].VdwRadii=1.88/*v*/; element[18].ColorName="LightGrey";

  element[19].Name="K "; element[19].VdwRadii=2.75/*v*/; element[19].ColorName="HotPink";
  element[20].Name="CA"; element[20].VdwRadii=2.758/*m1.97*/; element[20].ColorName="HotPink";

  element[21].Name="SC"; element[21].VdwRadii=2.967/*m1.63*/; element[21].ColorName="HotPink";
  element[22].Name="TI"; element[22].VdwRadii=2.03/*m1.45*/; element[22].ColorName="HotPink";
  element[23].Name="V "; element[23].VdwRadii=1.834/*m1.31*/; element[23].ColorName="HotPink";
  element[24].Name="CR"; element[24].VdwRadii=1.75/*m1.25*/; element[24].ColorName="PaleVioletRed";
  element[25].Name="MN"; element[25].VdwRadii=1.568/*m1.12*/; element[25].ColorName="MidnightBlue";
  element[26].Name="FE"; element[26].VdwRadii=1.736/*m1.24*/; element[26].ColorName="SteelBlue";
  element[27].Name="CO"; element[27].VdwRadii=1.75/*m1.25*/; element[27].ColorName="SteelBlue";
  element[28].Name="NI"; element[28].VdwRadii=1.75/*m1.25*/; element[28].ColorName="DarkOliveGreen";
  element[29].Name="CU"; element[29].VdwRadii=1.792/*m1.28*/; element[29].ColorName="LightSkyBlue";
  element[30].Name="ZN"; element[30].VdwRadii=1.862/*m1.33*/; element[30].ColorName="AntiqueWhite";

  element[31].Name="GA"; element[31].VdwRadii=1.87/*v*/; element[31].ColorName="HotPink";
  element[32].Name="GE"; element[32].VdwRadii=2.10/*v*/; element[32].ColorName="HotPink";
  element[33].Name="AS"; element[33].VdwRadii=1.85/*v*/; element[33].ColorName="HotPink";
  element[34].Name="SE"; element[34].VdwRadii=1.90/*v*/; element[34].ColorName="HotPink";
  element[35].Name="BR"; element[35].VdwRadii=1.85/*v*/; element[35].ColorName="OrangeRed";
  element[36].Name="KR"; element[36].VdwRadii=2.02/*v*/; element[36].ColorName="HotPink";

  element[37].Name="RB"; element[37].VdwRadii=3.458/*m2.47*/; element[37].ColorName="HotPink";
  element[38].Name="SR"; element[38].VdwRadii=3.01/*m2.15*/; element[38].ColorName="HotPink";

  element[39].Name="Y "; element[39].VdwRadii=2.492/*m1.78*/; element[39].ColorName="HotPink";
  element[40].Name="ZR"; element[40].VdwRadii=2.226/*m1.59*/; element[40].ColorName="HotPink";
  element[41].Name="NB"; element[41].VdwRadii=2.002/*m1.43*/; element[41].ColorName="HotPink";
  element[42].Name="MO"; element[42].VdwRadii=1.904/*m1.36*/; element[42].ColorName="HotPink";
  element[43].Name="TC"; element[43].VdwRadii=1.89/*m1.35*/; element[43].ColorName="HotPink";
  element[44].Name="RU"; element[44].VdwRadii=1.862/*m1.33*/; element[44].ColorName="HotPink";
  element[45].Name="RH"; element[45].VdwRadii=1.89/*m1.35*/; element[45].ColorName="HotPink";
  element[46].Name="PD"; element[46].VdwRadii=1.932/*m1.38*/; element[46].ColorName="HotPink";
  element[47].Name="AG"; element[47].VdwRadii=2.016/*m1.44*/; element[47].ColorName="HotPink";
  element[48].Name="CD"; element[48].VdwRadii=2.086/*m1.49*/; element[48].ColorName="HotPink";

  element[49].Name="IN"; element[49].VdwRadii=2.282/*m1.63*/; element[49].ColorName="HotPink";
  element[50].Name="SN"; element[50].VdwRadii=1.974/*m1.41*/; element[50].ColorName="HotPink";
  element[51].Name="SB"; element[51].VdwRadii=2.03/*m1.45*/; element[51].ColorName="HotPink";
  element[52].Name="TE"; element[52].VdwRadii=2.06/*v*/; element[52].ColorName="HotPink";
  element[53].Name="I "; element[53].VdwRadii=1.98/*v*/; element[53].ColorName="MediumPurple";
  element[54].Name="XE"; element[54].VdwRadii=2.16/*v*/; element[54].ColorName="HotPink";

  element[55].Name="CS"; element[55].VdwRadii=3.724/*m2.66*/; element[55].ColorName="HotPink";
  element[56].Name="BA"; element[56].VdwRadii=3.038/*m2.17*/; element[56].ColorName="HotPink";

  element[57].Name="LA"; element[57].VdwRadii=2.618/*m1.87*/; element[57].ColorName="HotPink";
  element[58].Name="CE"; element[58].VdwRadii=2.562/*m1.83*/; element[58].ColorName="HotPink";
  element[59].Name="PR"; element[59].VdwRadii=2.548/*m1.82*/; element[59].ColorName="HotPink";
  element[60].Name="ND"; element[60].VdwRadii=2.534/*m1.81*/; element[60].ColorName="HotPink";
  element[61].Name="PM"; element[61].VdwRadii=2.52/*m1.80*/; element[61].ColorName="HotPink";
  element[62].Name="SM"; element[62].VdwRadii=2.506/*m1.79*/; element[62].ColorName="HotPink";
  element[63].Name="EU"; element[63].VdwRadii=2.772/*m1.98*/; element[63].ColorName="HotPink";
  element[64].Name="GD"; element[64].VdwRadii=2.506/*m1.79*/; element[64].ColorName="HotPink";
  element[65].Name="TB"; element[65].VdwRadii=2.464/*m1.76*/; element[65].ColorName="HotPink";
  element[66].Name="DY"; element[66].VdwRadii=2.45/*m1.75*/; element[66].ColorName="HotPink";
  element[67].Name="HO"; element[67].VdwRadii=2.436/*m1.74*/; element[67].ColorName="HotPink";
  element[68].Name="ER"; element[68].VdwRadii=2.422/*m1.73*/; element[68].ColorName="HotPink";
  element[69].Name="TM"; element[69].VdwRadii=2.408/*m1.72*/; element[69].ColorName="HotPink";
  element[70].Name="YB"; element[70].VdwRadii=2.716/*m1.94*/; element[70].ColorName="HotPink";
  element[71].Name="LU"; element[71].VdwRadii=2.408/*m1.72*/; element[71].ColorName="HotPink";

  element[72].Name="HF"; element[72].VdwRadii=2.184/*m1.56*/; element[72].ColorName="HotPink";
  element[73].Name="TA"; element[73].VdwRadii=2.002/*m1.43*/; element[73].ColorName="HotPink";
  element[74].Name="W "; element[74].VdwRadii=1.918/*m1.37*/; element[74].ColorName="HotPink";
  element[75].Name="RE"; element[75].VdwRadii=1.918/*m1.37*/; element[75].ColorName="HotPink";
  element[76].Name="OS"; element[76].VdwRadii=1.876/*m1.34*/; element[76].ColorName="HotPink";
  element[77].Name="IR"; element[77].VdwRadii=1.904/*m1.36*/; element[77].ColorName="HotPink";
  element[78].Name="PT"; element[78].VdwRadii=1.946/*m1.39*/; element[78].ColorName="HotPink";
  element[79].Name="AU"; element[79].VdwRadii=2.016/*m1.44*/; element[79].ColorName="LightGoldenrodYellow";
  element[80].Name="HG"; element[80].VdwRadii=2.1/*m1.50*/; element[80].ColorName="HotPink";

  element[81].Name="TL"; element[81].VdwRadii=1.96/*v*/; element[81].ColorName="HotPink";
  element[82].Name="PB"; element[82].VdwRadii=2.45/*m1.75*/; element[82].ColorName="HotPink";
  element[83].Name="BI"; element[83].VdwRadii=2.184/*m1.56*/; element[83].ColorName="HotPink";
  element[84].Name="PO"; element[84].VdwRadii=2.2/***/; element[84].ColorName="HotPink";
  element[85].Name="AT"; element[85].VdwRadii=2.2/***/; element[85].ColorName="HotPink";
  element[86].Name="RN"; element[86].VdwRadii=2.2/***/; element[86].ColorName="HotPink";

  element[87].Name="FR"; element[87].VdwRadii=2.2/***/; element[87].ColorName="HotPink";
  element[88].Name="RA"; element[88].VdwRadii=2.2/***/; element[88].ColorName="HotPink";

  element[89].Name="AC"; element[89].VdwRadii=2.632/*m1.88*/; element[89].ColorName="HotPink";
  element[90].Name="TH"; element[90].VdwRadii=2.52/*m1.80*/; element[90].ColorName="HotPink";
  element[91].Name="PA"; element[91].VdwRadii=2.254/*m1.61*/; element[91].ColorName="HotPink";
  element[92].Name="U "; element[92].VdwRadii=1.932/*m1.38*/; element[92].ColorName="HotPink";
  element[93].Name="NP"; element[93].VdwRadii=1.82/*m1.30*/; element[93].ColorName="HotPink";
  element[94].Name="PU"; element[94].VdwRadii=2.24/*m1.60*/; element[94].ColorName="HotPink";
  element[95].Name="AM"; element[95].VdwRadii=2.534/*m1.81*/; element[95].ColorName="HotPink";
  element[96].Name="CM"; element[96].VdwRadii=2.2/***/; element[96].ColorName="HotPink";
  element[97].Name="BK"; element[97].VdwRadii=2.2/***/; element[97].ColorName="HotPink";
  element[98].Name="CF"; element[98].VdwRadii=2.2/***/; element[98].ColorName="HotPink";
  element[99].Name="ES"; element[99].VdwRadii=2.2/***/; element[99].ColorName="HotPink";
  element[100].Name="FM"; element[100].VdwRadii=2.2/***/; element[100].ColorName="HotPink";
  element[101].Name="MD"; element[101].VdwRadii=2.2/***/; element[101].ColorName="HotPink";
  element[102].Name="NO"; element[102].VdwRadii=2.2/***/; element[102].ColorName="HotPink";
  element[103].Name="LR"; element[103].VdwRadii=2.2/***/; element[103].ColorName="HotPink";

  element[104].Name="RF"; element[104].VdwRadii=2.2/***/; element[104].ColorName="HotPink";
  element[105].Name="DB"; element[105].VdwRadii=2.2/***/; element[105].ColorName="HotPink";
  element[106].Name="SG"; element[106].VdwRadii=2.2/***/; element[106].ColorName="HotPink";
  element[107].Name="BH"; element[107].VdwRadii=2.2/***/; element[107].ColorName="HotPink";
  element[108].Name="HS"; element[108].VdwRadii=2.2/***/; element[108].ColorName="HotPink";
  element[109].Name="MT"; element[109].VdwRadii=2.2/***/; element[109].ColorName="HotPink";
}
